/**
 * @author Bharath A Reddy
 *
 * Notes: Compiles and Works only with JDK 1.2 Onwards
 */
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class ServletGenerator extends Frame implements ActionListener{
	Button open;
	Button generate;
	Button html;
	Button servlet;
	TextArea openText,generateText;
	Panel cardPan;
	CardLayout card;
	String file = null;

	public ServletGenerator(){
		open = new Button("Open");
		open.addActionListener(this);
		generate = new Button("Generate Servlet");
		generate.addActionListener(this);
		html = new Button("View HTML");
		html.addActionListener(this);
		servlet = new Button("View Servlet");
		servlet.addActionListener(this);
		openText = new TextArea();
		generateText = new TextArea();

		Panel openPan = new Panel();
		openPan.setLayout(new GridLayout(1,2));
		openPan.add(open);
		openPan.add(generate);

		Panel text = new Panel();
		text.setLayout(new GridLayout(1,2));
		text.add(html);
		text.add(servlet);

		cardPan = new Panel();
		cardPan.setLayout(card = new CardLayout());
		cardPan.add(openText,"HTML");
		cardPan.add(generateText,"Servlet");

		add("North",text);
		add("South",openPan);
		add("Center",cardPan);

		addWindowListener(
							new WindowAdapter(){
								public void windowClosing(WindowEvent we){
									System.exit(0);
								}
							}
			);
	}

	public void actionPerformed(ActionEvent ae){
		String cmd = ae.getActionCommand();
		if( cmd.equals("Open") ){
			FileDialog fd = new FileDialog(this,"Open",FileDialog.LOAD);
			fd.setVisible(true);
			file = fd.getDirectory() + "\\" + fd.getFile();
			FileReader fr = null;
			try{
				card.show(cardPan,"HTML");
				fr = new FileReader(new File(file));
				BufferedReader br = new BufferedReader(fr);
				String st = "";
				openText.setText("");
				while( (st = br.readLine()) != null ){
					openText.append(st + "\n");
				}
				br.close();
				fr.close();
			}catch(Exception ex){
				ex.printStackTrace();
			}
		}else if(cmd.equals("Generate Servlet")){
			FileReader fr = null;
			try{
				card.show(cardPan,"Servlet");
				fr = new FileReader(new File(file));
				BufferedReader br = new BufferedReader(fr);
				String st = "";

				generateText.setText("");
				generateServletHeaders();
				while( (st = br.readLine()) != null ){
					if( !st.trim().equals("") ){
						String rpst = replace(st);
						System.out.println(rpst);
						generateText.append("\t\t\tout.println(\""+ rpst + "\");\n");
					}
				}
				generateText.append("\t\t\tout.close();\n");
				generateText.append("\t\t}catch(Exception ex){\n");
				generateText.append("\t\t\tex.printStackTrace();\n");
				generateText.append("\t\t}\n");
				generateText.append("\t}\n");
				generateText.append("}\n");
				br.close();
				fr.close();
			}catch(Exception ex){
				ex.printStackTrace();
			}
		}else if(cmd.equals("View HTML")){
			card.show(cardPan,"HTML");
		}else if(cmd.equals("View Servlet")){
			card.show(cardPan,"Servlet");
		}

	}

	public String replace(String st){
		StringBuffer sb = new StringBuffer(st);
		String rpString = "\\\"";
		for(int i=0 ; i < sb.length() ; i++ ){
			char c = st.charAt(i);
			if( c == '"' ){
				sb.replace(i,i+1,"\\\"");
				i++;
				if( i >= sb.length() ){
					break;
				}
				st = sb.toString();
			}
		}
		st = sb.toString();
		return st;
	}

	public void generateServletHeaders(){
		generateText.append("import java.io.*;\n");
		generateText.append("import javax.servlet.*;\n");
		generateText.append("import javax.servlet.http.*;\n\n");
		generateText.append("public class TestServlet extends HttpServlet{\n");
		generateText.append("\tpublic void init(ServletConfig sc){\n");
		generateText.append("\t\ttry{\n");
		generateText.append("\t\t\tsuper.init(sc);\n");
		generateText.append("\t\t}catch(Exception ex){\n");
		generateText.append("\t\t\tex.printStackTrace();\n");
		generateText.append("\t\t}\n");
		generateText.append("\t}\n");
		generateText.append("\tpublic void service(HttpServletRequest request , HttpServletResponse response){\n");
		generateText.append("\t\tresponse.setContentType(\"text/html\");\n");
		generateText.append("\t\tPrintWriter out = null;\n");
		generateText.append("\t\ttry{\n");
		generateText.append("\t\t\tout = response.getWriter();\n");
	}

	public static void main(String[] args){
		ServletGenerator ser = new ServletGenerator();
		ser.setSize(600,400);
		ser.setVisible(true);
	}
}